// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.25.0
// source: queries.sql

package queries

import (
	"context"
	"database/sql"
	"time"

	"github.com/google/uuid"
)

const samenvoegingGet = `-- name: SamenvoegingGet :many
SELECT id, vreemdeling_leidend_id, vreemdeling_vervallen_id, created_at
FROM bvv_backend.samenvoeging
WHERE vreemdeling_leidend_id=$1 or vreemdeling_vervallen_id=$1
`

func (q *Queries) SamenvoegingGet(ctx context.Context, vreemdelingLeidendID string) ([]*BvvBackendSamenvoeging, error) {
	rows, err := q.query(ctx, q.samenvoegingGetStmt, samenvoegingGet, vreemdelingLeidendID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*BvvBackendSamenvoeging{}
	for rows.Next() {
		var i BvvBackendSamenvoeging
		if err := rows.Scan(
			&i.ID,
			&i.VreemdelingLeidendID,
			&i.VreemdelingVervallenID,
			&i.CreatedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const samenvoegingInsert = `-- name: SamenvoegingInsert :exec
INSERT INTO bvv_backend.samenvoeging
(id, vreemdeling_leidend_id, vreemdeling_vervallen_id, created_at)
VALUES (
    $1, $2, $3, $4
)
`

type SamenvoegingInsertParams struct {
	ID                     uuid.UUID
	VreemdelingLeidendID   string
	VreemdelingVervallenID string
	CreatedAt              time.Time
}

func (q *Queries) SamenvoegingInsert(ctx context.Context, arg *SamenvoegingInsertParams) error {
	_, err := q.exec(ctx, q.samenvoegingInsertStmt, samenvoegingInsert,
		arg.ID,
		arg.VreemdelingLeidendID,
		arg.VreemdelingVervallenID,
		arg.CreatedAt,
	)
	return err
}

const vreemdelingCount = `-- name: VreemdelingCount :one
SELECT count(id)
FROM bvv_backend.vreemdeling
`

func (q *Queries) VreemdelingCount(ctx context.Context) (int64, error) {
	row := q.queryRow(ctx, q.vreemdelingCountStmt, vreemdelingCount)
	var count int64
	err := row.Scan(&count)
	return count, err
}

const vreemdelingCreate = `-- name: VreemdelingCreate :exec
INSERT INTO bvv_backend.vreemdeling (
    id, vreemdelingnummer, name, searchname, birthdate
)
VALUES ($1, $2, $3, $4, $5)
`

type VreemdelingCreateParams struct {
	ID                uuid.UUID
	Vreemdelingnummer string
	Name              sql.NullString
	Searchname        sql.NullString
	Birthdate         sql.NullTime
}

func (q *Queries) VreemdelingCreate(ctx context.Context, arg *VreemdelingCreateParams) error {
	_, err := q.exec(ctx, q.vreemdelingCreateStmt, vreemdelingCreate,
		arg.ID,
		arg.Vreemdelingnummer,
		arg.Name,
		arg.Searchname,
		arg.Birthdate,
	)
	return err
}

const vreemdelingDeleteById = `-- name: VreemdelingDeleteById :exec
UPDATE bvv_backend.vreemdeling
SET deleted_at = NOW()
WHERE id = $1
`

func (q *Queries) VreemdelingDeleteById(ctx context.Context, id uuid.UUID) error {
	_, err := q.exec(ctx, q.vreemdelingDeleteByIdStmt, vreemdelingDeleteById, id)
	return err
}

const vreemdelingDeleteByNummer = `-- name: VreemdelingDeleteByNummer :exec
UPDATE bvv_backend.vreemdeling
SET deleted_at = NOW()
WHERE vreemdelingnummer = $1
`

func (q *Queries) VreemdelingDeleteByNummer(ctx context.Context, vreemdelingnummer string) error {
	_, err := q.exec(ctx, q.vreemdelingDeleteByNummerStmt, vreemdelingDeleteByNummer, vreemdelingnummer)
	return err
}

const vreemdelingGetById = `-- name: VreemdelingGetById :one
SELECT id, vreemdelingnummer, name, searchname, birthdate, created_at, updated_at, deleted_at
FROM bvv_backend.vreemdeling
WHERE id = $1 AND deleted_at IS NULL
`

func (q *Queries) VreemdelingGetById(ctx context.Context, id uuid.UUID) (*BvvBackendVreemdeling, error) {
	row := q.queryRow(ctx, q.vreemdelingGetByIdStmt, vreemdelingGetById, id)
	var i BvvBackendVreemdeling
	err := row.Scan(
		&i.ID,
		&i.Vreemdelingnummer,
		&i.Name,
		&i.Searchname,
		&i.Birthdate,
		&i.CreatedAt,
		&i.UpdatedAt,
		&i.DeletedAt,
	)
	return &i, err
}

const vreemdelingGetByNummer = `-- name: VreemdelingGetByNummer :one
SELECT id, vreemdelingnummer, name, searchname, birthdate, created_at, updated_at, deleted_at
FROM bvv_backend.vreemdeling
WHERE vreemdelingnummer = $1 AND deleted_at IS NULL
`

func (q *Queries) VreemdelingGetByNummer(ctx context.Context, vreemdelingnummer string) (*BvvBackendVreemdeling, error) {
	row := q.queryRow(ctx, q.vreemdelingGetByNummerStmt, vreemdelingGetByNummer, vreemdelingnummer)
	var i BvvBackendVreemdeling
	err := row.Scan(
		&i.ID,
		&i.Vreemdelingnummer,
		&i.Name,
		&i.Searchname,
		&i.Birthdate,
		&i.CreatedAt,
		&i.UpdatedAt,
		&i.DeletedAt,
	)
	return &i, err
}

const vreemdelingSearchByNameAndBirthdate = `-- name: VreemdelingSearchByNameAndBirthdate :many
SELECT id, vreemdelingnummer, name, searchname, birthdate, created_at, updated_at, deleted_at
FROM bvv_backend.vreemdeling
WHERE (searchname ILIKE '%' || $1 || '%' OR $1 IS NULL)
AND (birthdate = $2 OR $2 IS NULL)
AND deleted_at IS NULL
ORDER BY vreemdelingnummer asc
`

type VreemdelingSearchByNameAndBirthdateParams struct {
	Name      sql.NullString
	Birthdate sql.NullTime
}

func (q *Queries) VreemdelingSearchByNameAndBirthdate(ctx context.Context, arg *VreemdelingSearchByNameAndBirthdateParams) ([]*BvvBackendVreemdeling, error) {
	rows, err := q.query(ctx, q.vreemdelingSearchByNameAndBirthdateStmt, vreemdelingSearchByNameAndBirthdate, arg.Name, arg.Birthdate)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*BvvBackendVreemdeling{}
	for rows.Next() {
		var i BvvBackendVreemdeling
		if err := rows.Scan(
			&i.ID,
			&i.Vreemdelingnummer,
			&i.Name,
			&i.Searchname,
			&i.Birthdate,
			&i.CreatedAt,
			&i.UpdatedAt,
			&i.DeletedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const vreemdelingUpdateById = `-- name: VreemdelingUpdateById :exec
UPDATE bvv_backend.vreemdeling
SET vreemdelingnummer = $2, name = $3, searchname = $4, birthdate = $5
WHERE id = $1
`

type VreemdelingUpdateByIdParams struct {
	ID                uuid.UUID
	Vreemdelingnummer string
	Name              sql.NullString
	Searchname        sql.NullString
	Birthdate         sql.NullTime
}

func (q *Queries) VreemdelingUpdateById(ctx context.Context, arg *VreemdelingUpdateByIdParams) error {
	_, err := q.exec(ctx, q.vreemdelingUpdateByIdStmt, vreemdelingUpdateById,
		arg.ID,
		arg.Vreemdelingnummer,
		arg.Name,
		arg.Searchname,
		arg.Birthdate,
	)
	return err
}

const vreemdelingUpdateByNummer = `-- name: VreemdelingUpdateByNummer :exec
UPDATE bvv_backend.vreemdeling
SET vreemdelingnummer = $2, name = $3, searchname = $4, birthdate = $5
WHERE vreemdelingnummer = $1
`

type VreemdelingUpdateByNummerParams struct {
	Vreemdelingnummer   string
	Vreemdelingnummer_2 string
	Name                sql.NullString
	Searchname          sql.NullString
	Birthdate           sql.NullTime
}

func (q *Queries) VreemdelingUpdateByNummer(ctx context.Context, arg *VreemdelingUpdateByNummerParams) error {
	_, err := q.exec(ctx, q.vreemdelingUpdateByNummerStmt, vreemdelingUpdateByNummer,
		arg.Vreemdelingnummer,
		arg.Vreemdelingnummer_2,
		arg.Name,
		arg.Searchname,
		arg.Birthdate,
	)
	return err
}
